
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class PaletteExtensibles extends Aide2 {
  int L=100,H=100;
  int S=2;
  int n=2;
  Pave pave,paveDroit,paveArc90,paveDroitLong,paveArc90Grand;
  //String texte="";
  
  void settings() {
    size((int)(L*ZOOM+BORDURE+BORDURE), // taille de la fenetre
         (int)(H*ZOOM+BORDURE+BORDURE),
         P2D); // mode graphique 2D
  }

  void setup() {
      noStroke(); 
      surface.setTitle("Palette extensibles");
      //palette=new Palette(BORDURE,BORDURE,5); // une palette   tests
      //pave=new PaveArc90Grand(n);
      
      paveDroit=new PaveDroitLong(1);
      paveArc90=new PaveArc90Grand(1);
      paveDroitLong=new PaveDroitLong(n);
      paveArc90Grand=new PaveArc90Grand(n);
    }
    
  void draw() { 
    background(GRIS_FOND);  
    translate(BORDURE,BORDURE);
    stroke(0); noFill(); rect(0,0,9*ZOOM,9*ZOOM); rect(0,(9+S)*ZOOM,9*ZOOM,9*ZOOM); //  rectangles
    noStroke(); 
    textSize(40); fill(NOIR); textAlign(CENTER,CENTER); text(""+n,4.5*ZOOM,(4.5+2*9+S)*ZOOM);
    textSize(20); fill(NOIR); textAlign(LEFT,TOP); if (pave!=null) text(affichage(),0,(H-15)*ZOOM);    
    scale(ZOOM);
    //pushMatrix();
    paveDroit.dessiner(); translate(9+S,0); paveDroitLong.dessiner(); translate(-(9+S),+(9+S)); 
    paveArc90.dessiner(); translate(9+S,0); paveArc90Grand.dessiner(); 
    //popMatrix();
  }
    
  void mouseClicked() { float mx,my; Pave p=null; //println("click "+mouseX+" "+mouseY);
    mx=mouseX-BORDURE; my=mouseY-BORDURE; 
    if (mx>=0 && mx<9*ZOOM && my>=0 && my<9*ZOOM) p=paveDroit;
    my-=(9+S)*ZOOM; //println(my);
    if (mx>=0 && mx<9*ZOOM && my>=0 && my<9*ZOOM) p=paveArc90;
    //if (p==null) return; println("dans"); // pas dans un des paves
    if (p==null) return; else pave=p; 
    if (pave==null) return;
    if (mouseButton==LEFT) { p.rotation(); }
    if (mouseButton==RIGHT) { p.symetrie(); }
    if (pave!=null) clipboard.setContents(new java.awt.datatransfer.StringSelection(affichage()),null);
    //texte=affichage();
  }
  void mouseMoved () { float mx,my; Pave p=null;
    mx=mouseX-BORDURE; my=mouseY-BORDURE; 
    if (mx>=0 && mx<9*ZOOM && my>=0 && my<9*ZOOM) p=paveDroit;
    my-=(9+S)*ZOOM; //println(my);
    if (mx>=0 && mx<9*ZOOM && my>=0 && my<9*ZOOM) p=paveArc90;
    if (p==null) return; else pave=p; 
    if (pave!=null) clipboard.setContents(new java.awt.datatransfer.StringSelection(affichage()),null);
  }
  
  void mouseWheel(MouseEvent e) { float x=e.getCount();
    //println("wheel "+x+"   "+n+"   "+pave);
    n-=x; if (n<2) n=2; if (n>=10) n=10;
    //pave=new PaveArc90Grand(n);
    paveDroitLong=new PaveDroitLong(n);
    paveArc90Grand=new PaveArc90Grand(n);
    clipboard.setContents(new java.awt.datatransfer.StringSelection(affichage()),null);
  }  

  String affichage() { String r="new "; // string worker ?
    if (pave==null) return "";
    r+=pave.nom;
    pave.simplifier();
    r+="("; r+=n; r+=")";
    if (pave.sym) r+=".symetrie()";
    if (pave.rot==1) r+=".rotation()"; 
    if (pave.rot>=2) r+=".rotation("+pave.rot+")";
    r+=";";  //println(r);
    return r; 
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
