
// Aide a l a fabrication de TCOs pour l'article "TCOs en Processing (2)"
// version 1 du 31 decembre 2017
// Pierre Lecouffe


// manque simplifications sur nouveaux paves

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// constantes

final static int GRIS_FOND=#D3D3D3,GRIS=#7F7F7F,NOIR=#000000,GRIS_FONCE=#555555; // couleurs
final static int ROUGE=#FF0000,VIOLET=#FF00FF,BLANC=#FFFFFF,JAUNE=#FFFF00,VERT=#00FF00; // couleur pour signaux

final int TAILLE_CASE=9; // cote d'une case en pixels
final int BORDURE=10; // bordure de la fenetre en pixels
final int ZOOM=5; // taux de zoom

final int LIGNES=3,COLONNES=20; // nombre de lignes et de colonnes

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// variables globales

Palette palette;
//static Cible[] cibles; 

java.awt.datatransfer.Clipboard clipboard=java.awt.Toolkit.getDefaultToolkit().getSystemClipboard();

static String path; // le path du sketch (besoin pour charger les images des signaux)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void settings() {
  size(COLONNES*TAILLE_CASE*ZOOM+BORDURE+BORDURE, // taille de la fenetre
       LIGNES*TAILLE_CASE*ZOOM+BORDURE+BORDURE,
       P2D); // mode graphique 2D
       path=sketchPath(); //println(path);
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

void setup() {
  noStroke(); 
  surface.setTitle("Palette de base");
  palette=new Palette(BORDURE,BORDURE,ZOOM); // palette paves de base

  PApplet.runSketch(new String[]{"macosx"},new PaletteSignaux()); 
  PApplet.runSketch(new String[]{"macosx"},new PaletteExtensibles()); 
  
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw() { 
  background(GRIS_FOND);  
  palette.dessiner(); // affichage palette
  //image(cibles[0].image,0,0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void mouseClicked() { 
  palette.clicked(mouseX,mouseY);
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

void mouseMoved () {
  palette.moved(mouseX,mouseY);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////